#include "App.h"
#include "stdio.h"

App::App()
{
    img.allocate(640, 480, OF_IMAGE_GRAYSCALE);


    pFirei = new cjxFireiCamera();
    pFirei->ListDevices();
    pFirei->OpenCamera(0);
    pFirei->SetGamma(0);
    pFirei->SetGain(255);


//    oids.push_back(OIDpair("BRIGHTNESS", OID_BRIGHTNESS_CONTROL));
//    oids.push_back(OIDpair("AUTO_EXPOSURE", OID_AUTO_EXPOSURE_CONTROL));
//    oids.push_back(OIDpair("SHARPNESS", OID_SHARPNESS_CONTROL));
//    oids.push_back(OIDpair("UB", OID_UB_CONTROL));
//    oids.push_back(OIDpair("VR", OID_VR_CONTROL));
//    oids.push_back(OIDpair("HUE", OID_HUE_CONTROL));
//    oids.push_back(OIDpair("SATURATION", OID_SATURATION_CONTROL));
//    oids.push_back(OIDpair("GAMMA", OID_GAMMA_CONTROL));
//    oids.push_back(OIDpair("SHUTTER", OID_SHUTTER_CONTROL));
//    oids.push_back(OIDpair("GAIN", OID_GAIN_CONTROL));
//    oids.push_back(OIDpair("IRIS", OID_IRIS_CONTROL));
//    oids.push_back(OIDpair("FOCUS", OID_FOCUS_CONTROL));
//    oids.push_back(OIDpair("TEMPERATURE", OID_TEMPERATURE_CONTROL));
//    oids.push_back(OIDpair("TRIGGER", OID_TRIGGER_CONTROL));
//    oids.push_back(OIDpair("ZOOM", OID_ZOOM_CONTROL));
//    oids.push_back(OIDpair("PAN", OID_PAN_CONTROL));
//    oids.push_back(OIDpair("TILT", OID_TILT_CONTROL));
//    oids.push_back(OIDpair("OPTICAL_FILTER", OID_OPTICAL_FILTER_CONTROL));
//    oid = 0;
//    oidvalue = 0;
}

App::~App()
{
    delete pFirei;
}

//--------------------------------------------------------------
void
App::update()
{
    pFirei->Update();
    if (pFirei->IsFrameNew())
        img.setFromPixels(pFirei->GetPixels(), 640, 480, OF_IMAGE_GRAYSCALE);
}

//--------------------------------------------------------------
void
App::draw()
{
	ofBackground(0,0,0);

    glColor3f(1,1,1);
    img.draw(0,0,640, 480);

    glColor3f(0.3, 1.0, 0.3);

    char pcText[128];
    sprintf(pcText, "FPS: %3.2f\n", ofGetFrameRate());
    ofDrawBitmapString(pcText, 20, 30);
}

//--------------------------------------------------------------
void
App::keyPressed(int key)
{
    switch (key)
    {
//    case '1':
//        oid++;
//        oidvalue = 0;
//        if (oid >= oids.size()) oid = 0;
//        break;
//    case '2':
//        printf("[APP] %s -> %d\n", oids.at(oid).name.c_str(), oidvalue);
//        pFirei->SetProperty(oids.at(oid).oid, oidvalue);
//        oidvalue++;
//        break;
    case '3':
        pFirei->ListDevices();
        break;
    case '4':
        pFirei->SetSharpness(0);
        break;
    case '5':
        pFirei->SetSharpness(128);
        break;
    }
}

//--------------------------------------------------------------
void
App::keyReleased(int key)
{
}

//--------------------------------------------------------------
void
App::mouseMoved(int x, int y )
{
}

//--------------------------------------------------------------
void
App::mouseDragged(int x, int y, int button)
{
}

//--------------------------------------------------------------
void
App::mousePressed(int x, int y, int button)
{
}

//--------------------------------------------------------------
void
App::mouseReleased()
{
}
